#!/usr/bin/env bash

source_dir=$1
phylodump_dir=$2
if [ "$source_dir" = "" ]
then
  echo "usage: $0 <phylodb_source_directory> [phylodump_directory]"
  exit 1
fi

container=phylodb

run() {
  nixos-container run $container -- $*
}

# Main setup
nixos-container start $container
init_script=`nix-store --add store/init-phylodb.sh`
source_dir=`nix-store --add $source_dir`
run mkdir -p /var/lib/phyloalps/phylodb
run cp -a $source_dir/* /var/lib/phyloalps/phylodb/
if [ "$phylodump_dir" \!= "" ]
then
  phylodump_dir=`nix-store --add $phylodump_dir`
  run mkdir -p /var/lib/phyloalps/phylodump
  run cp -a $phylodump_dir/* /var/lib/phyloalps/phylodump/
fi
run mkdir -p /var/lib/phyloalps/phylodb/log
run touch /var/lib/phyloalps/phylodb/log/debug.log
run chown -R phyloalps /var/lib/phyloalps
run bash $init_script
