{ config, pkgs, ... }:
{
  containers.phylotest =
  { config =
    { config, pkgs, ... }:
    {

      environment.systemPackages = with pkgs; [
        coreutils
        findutils
        su
        vim
        (python36.withPackages(ps: with ps; [pip virtualenv webtest]))
      ];

      services.openssh.enable = true;

      networking.hosts = {
        "127.0.0.1" = [ "localhost" "data.phylodev.org" ];
        "::1" = [ "localhost" ];
      };

      users.extraUsers.phyloalps = {
        isNormalUser = true;
      };
    };
  };
}
