#!/usr/bin/env bash

source_dir=$1
phylodump_dir=$2
if [ "$source_dir" = "" ]
then
  echo "usage: $0 <phylodb_source_directory> [phylodump_directory]"
  exit 1
fi

container=phylotest

run() {
  nixos-container run $container -- $*
}

nixos-container status phylodb |grep up 2>&1 >/dev/null
if [ "$?" \!= "0" ]
then
  echo
  echo "*******************************************************"
  echo "BUILDING PHYLODB CONTAINER..."
  echo "*******************************************************"
  echo
  ./init-phylodb-container.sh $source_dir $phylodump_dir
fi
nixos-container status phylotest |grep up 2>&1 >/dev/null
if [ "$?" \!= "0" ]
then
  echo
  echo "*******************************************************"
  echo "BUILDING PHYLOTEST CONTAINER..."
  echo "*******************************************************"
  echo
  ./init-phylotest-container.sh
fi
echo
echo "*******************************************************"
echo "RUNNING TESTS..."
echo "*******************************************************"
echo
run_script=`nix-store --add store/run.sh`
run bash $run_script

RC=$?
if [ "$RC" \!= "0" ]
then
  echo -e "\e[101mTESTS FAILED!!\e[0m"
  exit $RC
else
  echo -e "\e[1mTESTS OK\e[0m"
fi
